#include "fstream.h"
#include "dir.h"
#include "string.h"
#include "ctype.h"
template<class generico> class LISTBOX;
template<class generico>
class nodo_lista{
	generico inf;
	nodo_lista<generico> *sig;
	public:
		friend class LISTBOX<generico>;
		nodo_lista(generico);
}
template<class generico>
nodo_lista<generico>::nodo_lista(generico datos){
	inf=datos;sig=NULL;
}

//***********************************************************************
//////////////////////////////////////////////////////////////////////////////
//********************* OBJETO LIST BOX ************************************
template<class generico>
class LISTBOX{
	AYUDA ayuda;
	int x,y,x2,y2,lines,ancho,indice,num,primero,esvisible,escoje,color,scroll,reserva;
	char *titulo;
	void far*Bajolist;
	nodo_lista<generico> *inicio,*fin;
	int dentro1();
	int dentro2();
	void dibuja(int n,int est);
	void dibuscroll();
	void refresh();
	void selec();
	int dentroi();
	public:
		LISTBOX(int,int,int,int,char *,int);
		~LISTBOX();
		//void insertar_inicio(generico);
		void insertar_final(generico);
		//void eliminar_inicio();
		//void eliminar_final();
		char *text(int z);
		//generico nodo(int z);
		generico nodo();
		generico *nodopuntero();
		int visible(){return(esvisible);}
		int actual(){return(indice);}
		int max(){return(num);}
		void selecciona(int);
		void get();
		void put();
		void show();
		void hide();
		//void ultimo();
		void primer(){primero=indice=0;}
		void vaciar();
		void lineas(int n){lines=n;y2=y+(12*lines);}
		void graba(char *);
		void carga(char *);
		void eliminar();
		int verifica();
		void cambia(char *,int);
		void imprime();
};
//************************** elimina registro seleccionado ******************
template<class generico>
void LISTBOX<generico>::eliminar(){
	if(indice!=0){
		nodo_lista<generico> *temp=inicio,*temp2;
		if(indice==1){
			inicio=inicio->sig;
			delete temp;
			}
		else{
			for(int i=2;i<indice;++i)
				temp=temp->sig;
			temp2=temp->sig;
			temp->sig=temp->sig->sig;
			delete temp2;
			if(num==indice)fin=temp;
		}
	num--;
	if(indice>num)indice=num;
	if(esvisible)refresh();
	}
	else ayuda.mensaje("Seleccione un registro, para borrarlo...",1000);
}
//*************************** carga de archivo ******************************
template<class generico>
void LISTBOX<generico>::carga(char *nom){
	char cad[50];
	int itemp;
	hide();
	vaciar();
	generico temp;
	sprintf(cad,"No se encuentra el archivo %s!",nom);
	FILE *fp;int i,size=sizeof(generico);
	fp=fopen(nom,"rb");
	if(fp==NULL){ayuda.mensaje(cad,500);fclose(fp);return;}
	sprintf(cad,"Cargando archivo : %s ...",nom);
	ayuda.mensaje(cad,800);
	fread(&itemp,sizeof(int),1,fp);
	for(i=0;i<itemp;i++){
		fread(&temp,size,1,fp);
		insertar_final(temp);
		}
	fclose(fp);
	show();
	//hide();
}
//************************ graba en archivo **********************************
template<class generico>
void LISTBOX<generico>::graba(char *nom){
	nodo_lista<generico> *temp=inicio;
	FILE *fp;int i,size=sizeof(generico);
	mkdir("DATOS");
	fp=fopen(nom,"wb");
	if(fp==NULL){ayuda.mensaje("No se pudo crear archivo",1000);fclose(fp);return;}
	fwrite(&num,sizeof(int),1,fp);
	for(i=0;i<num;i++){
		fwrite(&(temp->inf),size,1,fp);
		temp=temp->sig;}
	ayuda.mensaje("Guardando...",500);
	fclose(fp);
}
//***************** develve la informacion de un nodo dado ******************
template<class generico>
generico LISTBOX<generico>::nodo(){
	nodo_lista<generico> *temp=inicio;
	for(int i=1;(i<indice)&&(temp!=NULL);++i)
		temp=temp->sig;
	if(temp==NULL) cout<<"No existe nodo";
	return(temp->inf);
}
//***************** develve puntero a la informacion de un nodo dado ******************
template<class generico>
generico *LISTBOX<generico>::nodopuntero(){
	nodo_lista<generico> *temp=inicio;
	for(int i=1;(i<indice)&&(temp!=NULL);++i)
		temp=temp->sig;
	if(temp==NULL) cout<<"No existe nodo";
	return(&(temp->inf));
}

//************** devuelve el texto de un elemento de la lista ****************
template<class generico>
char *LISTBOX<generico>::text(int z){
	nodo_lista<generico> *temp=inicio;
	for(int i=1;(i<z)&&(temp!=NULL);++i)
		temp=temp->sig;
	return(texto(temp->inf));
}
/*
//************************ inserta al inicio ********************************
template<class generico>
void LISTBOX<generico>::insertar_inicio(generico dato){
	nodo_lista <generico> *temp=new nodo_lista<generico>(dato);
	if(temp==NULL){cout<<"No se pudo reservar memoria para nuevo nodo";return;}
	num++;
	if(inicio==NULL){
		inicio=fin=temp;}
	else{
		temp->sig=inicio;inicio=temp;
		}
	indice=0;
	if(esvisible==1)refresh();
}
*/
//************************ inserta al final **********************************
template<class generico>
void LISTBOX<generico>::insertar_final(generico dato){
	nodo_lista <generico> *temp=new nodo_lista<generico>(dato);
	if(temp==NULL){cout<<"No se pudo reservar memoria para nuevo nodo";return;}
	num++;
	if(inicio==NULL)
		inicio=fin=temp;
	else{
		fin->sig=temp;fin=temp;
		}
	if(esvisible==1)refresh();
}
/*
//************************ eliminar al inicio **********************************
template<class generico>
void LISTBOX<generico>::eliminar_inicio(){
	nodo_lista <generico> *temp=inicio;
	if(inicio!=NULL){
		inicio=inicio->sig;
		delete temp;
		num--;
		if(inicio==NULL)fin=NULL;
	}
	if(((primero+lines)>num)&&(primero>0))primero--;
	indice=0;
	if(esvisible==1)refresh();
}
//************************ eliminar en el fin **********************************
template<class generico>
void LISTBOX<generico>::eliminar_final(){
nodo_lista <generico> *temp;
if(inicio!=NULL){
	num--;temp=inicio;
	if(inicio->sig==NULL){
		delete inicio;inicio=fin=NULL;
		}
	else{
		nodo_lista<generico> *temp=inicio;
		while(temp->sig!=fin)
			temp=temp->sig;
		fin=temp;
		delete fin->sig;
		fin->sig=NULL;
		}
	}
	if(((primero+lines)>num)&&(primero>0))primero--;
	if(indice>num)indice=0;
	if(esvisible==1)refresh();
}

//************************** VA AL ULTIMO DE LA LISTA ************************
template <class generico>
void LISTBOX<generico>::ultimo(){
	if(num>lines) primero=num-lines;
	if(esvisible==1)refresh();
}
*/
//************************** SELECCIONA UN ITEM DESDE AFUERA *****************
template <class generico>
void LISTBOX<generico>::selecciona(int n){
	if((n>=0)&&(n<=num))indice=n;if(esvisible==1)refresh();}
//************************ SELECCIONA UN ITEM *********************************
template <class generico>
void LISTBOX<generico>::selec(){
	int sale;if(indice!=((sale=dentroi())+primero+1)){indice=(sale+primero+1);
	if(esvisible==1)refresh();
	}
}
//*********************** VERIFICA LOS BOTONES DE LISTA **********************
template <class generico>
int LISTBOX<generico>::verifica(){
	if ((num>lines)&&(scroll==0)&&esvisible) {scroll=1;show();}
	if ((num<=lines)&&(scroll==1)&&esvisible){scroll=0;show();}
	if ((dentroi()!=-1)&&mouse.click()&&esvisible) {
		selec();while(mouse.click()) mouse.actualiza();
		//mouse.cursor(C7);
		delay(150);
		//mouse.cursor(C1);
		return(1);}
	//if ((dentro1()||dentro2())&&esvisible)mouse.cursor(2);else mouse.cursor(1);
	if (dentro1()&&mouse.click()&&scroll&&esvisible){
		dibuja(0,1);if (primero>0){--primero;refresh();}
		delay(60);//while (mouse.click()) mouse.actualiza();
		dibuja(0,0);}
	if (dentro2()&&mouse.click()&&scroll&&esvisible){
		dibuja(1,1);if (primero<(num-lines)){++primero;refresh();}
		delay(60);//while (mouse.click()) mouse.actualiza();
		dibuja(1,0);}
	return(0);}

//************************** DENTRO DE ITEMS ****************************
template <class generico>
int LISTBOX<generico>::dentroi(){
	int i,mx,my,izq,der,sale=-1;mouse.datos(&mx,&my,&izq,&der);
	if((my>y)&&(my<y2)&&(mx>x)&&(mx<x2-17))
		for(i=0;(i<num)&&(i<lines);++i)
			if(my>(y+(i*12)+1)&&(my<=(y+(i*12)+13))) sale=i;
	return(sale);
}
//************************** DIBUJA BOTONES APLASTADOS ****************************
template <class generico>
void LISTBOX<generico>::dibuja(int n,int est){
int i;mhide();
if (n==0){
	if(est==0){setcolor(0);for(i=y+5;i<(y+9);++i) line(x2-5-i+y,i+1,x2-13+i-y,i+1);
		for(i=y+9;i<(y+12);++i) line(x2-11,i+1,x2-7,i+1);
		setcolor(15);line(x2-15,y+3,x2-3,y+3);line(x2-15,y+3,x2-15,y+14);
		setcolor(0);line(x2-15,y+14,x2-3,y+14);line(x2-3,y+14,x2-3,y+3);
		putpixel(x2-9,y+5,0);}
	else{setcolor(4);for(i=y+5;i<(y+9);++i) line(x2-5-i+y,i+1,x2-13+i-y,i+1);
		for(i=y+9;i<(y+12);++i) line(x2-11,i+1,x2-7,i+1);
		setcolor(0);line(x2-15,y+3,x2-3,y+3);line(x2-15,y+3,x2-15,y+14);
		setcolor(15);line(x2-15,y+14,x2-3,y+14);line(x2-3,y+14,x2-3,y+3);
		putpixel(x2-9,y+5,4);}
	}
if (n==1){
	if(est==0){setcolor(0);for(i=y2-5;i>(y2-9);--i) line(x2-9+(i-y2+4),i-1,x2-9-(i-y2+4),i-1);
		for(i=y2-9;i>(y2-12);--i) line(x2-11,i-1,x2-7,i-1);
		setcolor(15);line(x2-15,y2-14,x2-3,y2-14);line(x2-15,y2-3,x2-15,y2-14);
		setcolor(0);line(x2-15,y2-3,x2-3,y2-3);line(x2-3,y2-14,x2-3,y2-3);
		putpixel(x2-9,y2-5,0);}
	else{setcolor(4);for(i=y2-5;i>(y2-9);--i) line(x2-9+(i-y2+4),i-1,x2-9-(i-y2+4),i-1);
		for(i=y2-9;i>(y2-12);--i) line(x2-11,i-1,x2-7,i-1);
		setcolor(0);line(x2-15,y2-14,x2-3,y2-14);line(x2-15,y2-3,x2-15,y2-14);
		setcolor(15);line(x2-15,y2-3,x2-3,y2-3);line(x2-3,y2-14,x2-3,y2-3);
		putpixel(x2-9,y2-5,4);}
	}
mshow();
}

//****************************** dentro del scroll 1 ************************
template <class generico>
int LISTBOX<generico>::dentro1(){
	int mx,my,izq,der;mouse.datos(&mx,&my,&izq,&der);
	if((my>(y+3))&&(my<(y+14))&&(mx>(x2-14))&&(mx<(x2-4)))return(1);else return(0);
}
//****************************** dentro del scroll 2 ************************
template <class generico>
int LISTBOX<generico>::dentro2(){
	int mx,my,izq,der;mouse.datos(&mx,&my,&izq,&der);
	if((my<(y2-3))&&(my>(y2-14))&&(mx>(x2-14))&&(mx<(x2-4)))return(1);else return(0);
}

//************************** FUNCION QUE DIBUJA LOS TEXTOS ******************
template <class generico>
void LISTBOX<generico>::refresh(){
	if (esvisible==1){
		int i,j=0,sale;char cadena[90];
		nodo_lista<generico> *temp;
		mhide();setcolor(15);
		for(i=y+1;i<=y2-1;++i) line(x+1,i,x2-17,i);setcolor(0);
		settextjustify(LEFT_TEXT,CENTER_TEXT);settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
		i=0;temp=inicio;
		while((i<primero)&&(temp!=NULL)){
			i++;temp=temp->sig;
			}
		j=0;
		while((temp!=NULL)&&(j<lines)){
				strcpy(cadena,texto(temp->inf));
				outtextxy(x+5,y+7+(j*12),cadena);
				j++;
				temp=temp->sig;
			}
		if ((indice!=0)&&(indice<=primero+lines)&&(indice>primero)){
			setcolor(1);sale=indice-primero-1;
			for(i=y+(sale*12)+1;i<(y+(sale*12)+12);++i) line(x+1,i,x2-17,i);
			i=1;temp=inicio;
			while((i<indice)&&(temp!=NULL)){temp=temp->sig;i++;}
			if(temp!=NULL){strcpy(cadena,texto(temp->inf));
				setcolor(15);outtextxy(x+5,y+7+(sale*12),cadena);
			}else cout<<"ERROR";
		}

		mshow();
	}
}
//************************** FUNCION QUE imprime LOS TEXTOS ******************
template <class generico>
void LISTBOX<generico>::imprime(){
	ofstream impresora("PRN");
	char cadena[90];
	nodo_lista<generico> *temp;
	temp=inicio;
	ayuda.mensaje("Imprimiendo...",1000);
	impresora<<titulo<<endl<<endl;
	while(temp!=NULL){
		strcpy(cadena,texto(temp->inf));
		impresora<<cadena<<endl;
		temp=temp->sig;
	}
}

//v************************* FUNCION QUE VACIA LA LISTA *********************
template <class generico>
void LISTBOX<generico>::vaciar(){
	nodo_lista<generico> *temp=inicio,*tempsig;
	while(temp!=NULL){
		tempsig=temp->sig;
		delete temp;
		temp=tempsig;
	}
inicio=fin=NULL;num=indice=primero=0;escoje=-1;
if(esvisible==1)refresh();
}

//v********************FUNCION CONSTRUCTORA ***********************************
template <class generico>
LISTBOX<generico>::LISTBOX(int ex,int ey,int el,int ea,char *ti2,int col){
	scroll=num=indice=esvisible=primero=0;Bajolist=NULL;escoje=-1;
	inicio=fin=NULL;
	x=ex;y=ey;lines=el;ancho=ea;x2=x+ancho;y2=y+(12*lines);reserva=0;
	titulo=new char[strlen(ti2)+1];strcpy(titulo,ti2);color=col;
}
//*******************************************************
template <class generico>
void LISTBOX<generico>::cambia(char *ti2,int col){
	delete[]titulo;
	titulo=new char[strlen(ti2)+1];strcpy(titulo,ti2);color=col;
}
//v*************************** FUNCION DESTRUCTORA ***************************
template <class generico>
LISTBOX<generico>::~LISTBOX(){
	vaciar();
	delete[]titulo;
}
//v************************* GRABA EL GRAFICO BAJO LA LISTA ******************
template <class generico>
void LISTBOX<generico>::get(){
unsigned long int size;
	if(reserva==0){
		size=imagesize2(x-2,y-25,x2+2,y2+2);
		//if(size==(-1)){cout<<"El tamao es mayor a 64k";return;}
		Bajolist = farmalloc( size );
		if(Bajolist!=NULL){mhide();getimage(x-2,y-25,x2+2,y2+2,Bajolist);mshow();}
		else{cout<<"no se pudo reservar memoria para bajolist";return;}
		reserva=1;
	}
}
//v***************************** QUITA LA LISTA *******************************
template <class generico>
void LISTBOX<generico>::put(){
	if(reserva==1){
		mhide();putimage(x-2,y-25,Bajolist,COPY_PUT);
		mshow();farfree(Bajolist);Bajolist=NULL;
		reserva=0;
	}
}
//v*************************** DESPLIEGA LA LISTA *******************************
template <class generico>
void LISTBOX<generico>::show(){
	int i;mhide();esvisible=1;
	setcolor(7);for(i=y-25;i<(y-2);++i) line(x-2,i,x2+2,i);
	setcolor(0);rectangle(x-2,y-25,x2+2,y-3);
	settextjustify(LEFT_TEXT,CENTER_TEXT);settextstyle(TRIPLEX_FONT,HORIZ_DIR,3);
	setcolor(8);outtextxy(x+6,y-17,titulo);
	setcolor(color);outtextxy(x+5,y-18,titulo);
	setcolor(15);for(i=y-2;i<=(y2+2);++i) line(x-2,i,x2+2,i);
	setcolor(0);rectangle(x,y,x2,y2);rectangle(x-2,y-2,x2+2,y2+2);
	if (scroll!=0) dibuscroll();
	refresh();mshow();
}
//v********************** dibuja barra desplazamiento ***********************
template <class generico>
void LISTBOX<generico>::dibuscroll(){
	int i;setcolor(8);for(i=y+2;i<=(y2-2);++i) line(x2-16,i,x2-2,i);
	setcolor(7);for(i=y+3;i<(y+15);++i) line(x2-15,i,x2-3,i);
	for(i=y2-3;i>(y2-15);--i) line(x2-15,i,x2-3,i);
	dibuja(0,0);dibuja(1,0);
}
//v******************** funcion que esconde la lista ******************************
template <class generico>
void LISTBOX<generico>::hide(){
	if(esvisible==1){
		put();
		esvisible=scroll=0;
	}
}


